<template>
  <div class="mx-auto px-10 py-6">
    <div class="max-w-7xl mx-auto px-4 sm:px-6 md:px-8" v-if="project">
      <button @click="$router.go(-1)" class="mb-6 inline-flex items-center px-4 py-2 border border-transparent text-base font-medium rounded-md shadow-sm text-white bg-blue-500 hover:bg-blue-600 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500">
        Go Back
      </button>
      <router-link v-if="owner" :to="{name: 'UpdateProject', params: {id: project.id}}" class="mb-6 inline-flex items-center px-4 py-2 border border-transparent text-base font-medium rounded-md shadow-sm text-white bg-yellow-500 hover:bg-yellow-600 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-yellow-500 float-right">Edit</router-link>
      <div class="bg-white overflow-hidden shadow rounded-lg sm:divide-y sm:divide-gray-200 mb-6">
        <div class="md:flex md:items-center md:justify-between md:space-x-4 xl:border-b xl:pb-6 px-4 py-5">
          <h1 class="text-2xl font-bold text-gray-900">{{ project.title }}</h1>
        </div>
        <div class="px-4 py-5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
          <dt class="text-sm font-medium text-gray-500">
            Opened by
          </dt>
          <dd class="mt-1 text-sm text-gray-900 sm:mt-0 sm:col-span-2">
            {{ project.company.name }}
          </dd>
        </div>
        <div class="px-4 py-5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
          <dt class="text-sm font-medium text-gray-500">
            Description
          </dt>
          <dd class="mt-1 text-sm text-gray-900 sm:mt-0 sm:col-span-2">
            {{ project.description }}
          </dd>
        </div>
        <div v-if="project.email" class="px-4 py-5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
          <dt class="text-sm font-medium text-gray-500">
            Email address
          </dt>
          <dd class="mt-1 text-sm text-gray-900 sm:mt-0 sm:col-span-2">
            {{ project.email }}
          </dd>
        </div>
        <div v-if="project.phoneNumber" class="px-4 py-5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
          <dt class="text-sm font-medium text-gray-500">
            Phone Number
          </dt>
          <dd class="mt-1 text-sm text-gray-900 sm:mt-0 sm:col-span-2">
            {{ project.phoneNumber }}
          </dd>
        </div>
      </div>
      <div v-if="isLoggedIn && !this.owner">
        <h3>Démarrer une conversation</h3>
        <VumikForm v-model="discussionForm" @submit="discuss">
          <VumikInput type="textarea" name="message" />
          <VumikInput type="submit">Envoyer</VumikInput>
        </VumikForm>
      </div>
    </div>
    <success-notification v-if="!closeNotification && discussionId" @close="closeNotification = true">
      <slot slot="title">Le message a bien été envoyé !</slot>
      <a href="/dashboard/discussions" slot="content">Cliquez-ici pour accèder à votre nouvelle conversation !</a>
    </success-notification>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import SuccessNotification from '../../components/common/SuccessNotification.vue'

export default {
  name: 'ProjectsDetail',
  components: { SuccessNotification },
  data: () => ({
    discussionForm: {
      message: ''
    },
    discussionId: undefined,
    closeNotification: true
  }),
  computed: {
    ...mapGetters('project', ['getOne']),
    ...mapGetters('user', ['me']),
    ...mapGetters('auth', ['isLoggedIn']),
    project () {
      return this.getOne(this.$route.params.id)
    },
    owner () {
      return this.project.company.id === this.me?.company?.[0]?.id
    }
  },
  async beforeMount () {
    await this.fetchAll()
    this.meAction()
  },
  methods: {
    ...mapActions('user', { meAction: 'me' }),
    ...mapActions('project', ['fetchAll']),
    ...mapActions('discussion', ['createDiscussion']),
    async discuss () {
      this.discussionId = await this.createDiscussion({ projectId: this.project.id, message: { content: this.discussionForm.message } })
      this.discussionForm.message = ''
      this.closeNotification = false
    }
  }
}
</script>
